diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/wifi-phy.cc ns-3.41/src/wifi/model/wifi-phy.cc
--- ns-3.40/src/wifi/model/wifi-phy.cc	2023-09-27 13:30:37.918840000 -0700
+++ ns-3.41/src/wifi/model/wifi-phy.cc	2024-02-09 14:44:08.605795100 -0800
@@ -88,9 +88,15 @@
                 "Note that the channel width can be left unspecified (0) if the channel "
                 "number uniquely identify a frequency channel for the given standard and band.",
                 StringValue("{0, 0, BAND_UNSPECIFIED, 0}"),
-                MakeTupleAccessor<UintegerValue, UintegerValue, EnumValue, UintegerValue>(
-                    (void(WifiPhy::*)(const ChannelTuple&)) & WifiPhy::SetOperatingChannel),
-                MakeTupleChecker<UintegerValue, UintegerValue, EnumValue, UintegerValue>(
+                MakeTupleAccessor<UintegerValue,
+                                  UintegerValue,
+                                  EnumValue<WifiPhyBand>,
+                                  UintegerValue>((void(WifiPhy::*)(const ChannelTuple&)) &
+                                                 WifiPhy::SetOperatingChannel),
+                MakeTupleChecker<UintegerValue,
+                                 UintegerValue,
+                                 EnumValue<WifiPhyBand>,
+                                 UintegerValue>(
                     MakeUintegerChecker<uint8_t>(0, 233),
                     MakeUintegerChecker<uint16_t>(0, 160),
                     MakeEnumChecker(WifiPhyBand::WIFI_PHY_BAND_2_4GHZ,
@@ -349,6 +355,7 @@
       m_currentEvent(nullptr),
       m_previouslyRxPpduUid(UINT64_MAX),
       m_standard(WIFI_STANDARD_UNSPECIFIED),
+      m_maxModClassSupported(WIFI_MOD_CLASS_UNKNOWN),
       m_band(WIFI_PHY_BAND_UNSPECIFIED),
       m_sifs(Seconds(0)),
       m_slot(Seconds(0)),
@@ -401,12 +408,9 @@
 WifiPhy::DoDispose()
 {
     NS_LOG_FUNCTION(this);
-    m_endTxEvent.Cancel();
-    m_endPhyRxEvent.Cancel();
-    for (auto& phyEntity : m_phyEntities)
-    {
-        phyEntity.second->CancelAllEvents();
-    }
+
+    Reset();
+
     m_device = nullptr;
     m_mobility = nullptr;
     m_frameCaptureModel = nullptr;
@@ -420,12 +424,6 @@
     m_interference = nullptr;
     m_random = nullptr;
     m_state = nullptr;
-    m_currentEvent = nullptr;
-    for (auto& preambleEvent : m_currentPreambleEvents)
-    {
-        preambleEvent.second = nullptr;
-    }
-    m_currentPreambleEvents.clear();
 
     for (auto& phyEntity : m_phyEntities)
     {
@@ -460,13 +458,13 @@
 }
 
 void
-WifiPhy::RegisterListener(WifiPhyListener* listener)
+WifiPhy::RegisterListener(const std::shared_ptr<WifiPhyListener>& listener)
 {
     m_state->RegisterListener(listener);
 }
 
 void
-WifiPhy::UnregisterListener(WifiPhyListener* listener)
+WifiPhy::UnregisterListener(const std::shared_ptr<WifiPhyListener>& listener)
 {
     m_state->UnregisterListener(listener);
 }
@@ -947,6 +945,19 @@
 }
 
 void
+WifiPhy::SetMaxModulationClassSupported(WifiModulationClass modClass)
+{
+    NS_LOG_FUNCTION(this << modClass);
+    m_maxModClassSupported = modClass;
+}
+
+WifiModulationClass
+WifiPhy::GetMaxModulationClassSupported() const
+{
+    return m_maxModClassSupported;
+}
+
+void
 WifiPhy::ConfigureStandard(WifiStandard standard)
 {
     NS_LOG_FUNCTION(this << standard);
@@ -956,6 +967,11 @@
 
     m_standard = standard;
 
+    if (m_maxModClassSupported == WIFI_MOD_CLASS_UNKNOWN)
+    {
+        m_maxModClassSupported = GetModulationClassForStandard(m_standard);
+    }
+
     if (!m_operatingChannel.IsSet())
     {
         NS_LOG_DEBUG("Setting the operating channel first");
@@ -1094,37 +1110,30 @@
         return;
     }
 
-    Time delay = Seconds(0);
-
     if (IsInitialized())
     {
-        delay = GetDelayUntilChannelSwitch();
-    }
-
-    if (delay.IsStrictlyNegative())
-    {
-        // switching channel is not possible now
-        return;
-    }
-    if (delay.IsStrictlyPositive())
-    {
-        // switching channel has been postponed
-        void (WifiPhy::*fp)(const ChannelTuple&) = &WifiPhy::SetOperatingChannel;
-        Simulator::Schedule(delay, fp, this, channelTuple);
-        return;
+        const auto delay = GetDelayUntilChannelSwitch();
+        if (!delay.has_value())
+        {
+            // switching channel is not possible now
+            return;
+        }
+        if (delay.value().IsStrictlyPositive())
+        {
+            // switching channel has been postponed
+            void (WifiPhy::*fp)(const ChannelTuple&) = &WifiPhy::SetOperatingChannel;
+            Simulator::Schedule(delay.value(), fp, this, channelTuple);
+            return;
+        }
     }
 
     // channel can be switched now.
     DoChannelSwitch();
 }
 
-Time
+std::optional<Time>
 WifiPhy::GetDelayUntilChannelSwitch()
 {
-    m_powerRestricted = false;
-    m_channelAccessRequested = false;
-    m_currentEvent = nullptr;
-    m_currentPreambleEvents.clear();
     if (!IsInitialized())
     {
         // this is not channel switch, this is initialization
@@ -1132,14 +1141,14 @@
         return Seconds(0);
     }
 
-    Time delay = Seconds(0);
-
     NS_ASSERT(!IsStateSwitching());
+    std::optional<Time> delay;
     switch (m_state->GetState())
     {
     case WifiPhyState::RX:
         NS_LOG_DEBUG("drop packet because of channel switching while reception");
         AbortCurrentReception(CHANNEL_SWITCHING);
+        delay = Seconds(0);
         break;
     case WifiPhyState::TX:
         NS_LOG_DEBUG("channel switching postponed until end of current transmission");
@@ -1147,15 +1156,11 @@
         break;
     case WifiPhyState::CCA_BUSY:
     case WifiPhyState::IDLE:
-        m_endPhyRxEvent.Cancel();
-        for (auto& phyEntity : m_phyEntities)
-        {
-            phyEntity.second->CancelAllEvents();
-        }
+        Reset();
+        delay = Seconds(0);
         break;
     case WifiPhyState::SLEEP:
         NS_LOG_DEBUG("channel switching ignored in sleep mode");
-        delay = Seconds(-1); // negative value to indicate switching not possible
         break;
     default:
         NS_ASSERT(false);
@@ -1170,12 +1175,15 @@
 {
     NS_LOG_FUNCTION(this);
 
+    m_powerRestricted = false;
+    m_channelAccessRequested = false;
+
     // Update unspecified parameters with default values
     {
         auto& [number, width, band, primary20] = m_channelSettings;
-        if (band == static_cast<int>(WIFI_PHY_BAND_UNSPECIFIED))
+        if (band == WIFI_PHY_BAND_UNSPECIFIED)
         {
-            band = static_cast<int>(GetDefaultPhyBand(m_standard));
+            band = GetDefaultPhyBand(m_standard);
         }
         if (width == 0 && number == 0)
         {
@@ -1351,7 +1359,16 @@
     case WifiPhyState::CCA_BUSY:
     case WifiPhyState::IDLE:
         NS_LOG_DEBUG("setting sleep mode");
-        m_state->SwitchToSleep();
+        // The PHY object may be in CCA_BUSY state because it is receiving a preamble. Cancel
+        // preamble events before switching to sleep state
+        Reset();
+        // It may happen that we request to switch to sleep at the same time the reception of
+        // a PPDU ends. In such a case, WifiPhyStateHelper::GetState() does not return RX
+        // (m_endRx equals now), we get here and set the state to SLEEP. However,
+        // WifiPhyStateHelper::DoSwitchFromRx() may be called after this function (at the same
+        // simulation time), thus hitting the assert that checks that the state is IDLE or
+        // CCA_BUSY.
+        Simulator::ScheduleNow(&WifiPhyStateHelper::SwitchToSleep, m_state);
         break;
     case WifiPhyState::SLEEP:
         NS_LOG_DEBUG("already in sleep mode");
@@ -1368,12 +1385,7 @@
     NS_LOG_FUNCTION(this);
     m_powerRestricted = false;
     m_channelAccessRequested = false;
-    m_endPhyRxEvent.Cancel();
-    m_endTxEvent.Cancel();
-    for (auto& phyEntity : m_phyEntities)
-    {
-        phyEntity.second->CancelAllEvents();
-    }
+    Reset();
     m_state->SwitchToOff();
 }
 
@@ -1381,7 +1393,6 @@
 WifiPhy::ResumeFromSleep()
 {
     NS_LOG_FUNCTION(this);
-    m_currentPreambleEvents.clear();
     switch (m_state->GetState())
     {
     case WifiPhyState::TX:
@@ -1395,7 +1406,7 @@
     case WifiPhyState::SLEEP: {
         NS_LOG_DEBUG("resuming from sleep mode");
         m_state->SwitchFromSleep();
-        SwitchMaybeToCcaBusy(nullptr);
+        SwitchMaybeToCcaBusy();
         break;
     }
     default: {
@@ -1423,7 +1434,7 @@
     case WifiPhyState::OFF: {
         NS_LOG_DEBUG("resuming from off mode");
         m_state->SwitchFromOff();
-        SwitchMaybeToCcaBusy(nullptr);
+        SwitchMaybeToCcaBusy();
         break;
     }
     default: {
@@ -1725,7 +1736,7 @@
     NS_ASSERT(!m_state->IsStateTx() && !m_state->IsStateSwitching());
     NS_ASSERT(m_endTxEvent.IsExpired());
 
-    if (!txVector.IsValid())
+    if (!txVector.IsValid(m_band))
     {
         NS_FATAL_ERROR("TX-VECTOR is invalid!");
     }
@@ -1775,13 +1786,6 @@
         AbortCurrentReception(RECEPTION_ABORTED_BY_TX);
     }
 
-    for (auto& it : m_phyEntities)
-    {
-        it.second->CancelRunningEndPreambleDetectionEvents();
-    }
-    m_currentPreambleEvents.clear();
-    m_endPhyRxEvent.Cancel();
-
     if (m_powerRestricted)
     {
         NS_LOG_DEBUG("Transmitting with power restriction for " << txDuration.As(Time::NS));
@@ -1829,6 +1833,8 @@
     m_powerRestricted = false;
 
     Simulator::Schedule(txDuration, &WifiPhy::Reset, this);
+
+    Simulator::Schedule(txDuration, &WifiPhy::SwitchMaybeToCcaBusy, this, nullptr);
 }
 
 uint64_t
@@ -1854,7 +1860,8 @@
     {
         phyEntity.second->CancelAllEvents();
     }
-    SwitchMaybeToCcaBusy(nullptr);
+    m_endPhyRxEvent.Cancel();
+    m_endTxEvent.Cancel();
 }
 
 void
@@ -1864,8 +1871,9 @@
 {
     NS_LOG_FUNCTION(this << ppdu << rxDuration);
     WifiModulationClass modulation = ppdu->GetModulation();
-    auto it = m_phyEntities.find(modulation);
-    if (it != m_phyEntities.end())
+    NS_ASSERT(m_maxModClassSupported != WIFI_MOD_CLASS_UNKNOWN);
+    if (auto it = m_phyEntities.find(modulation);
+        it != m_phyEntities.end() && modulation <= m_maxModClassSupported)
     {
         it->second->StartReceivePreamble(ppdu, rxPowersW, rxDuration);
     }
@@ -1875,10 +1883,16 @@
         // structure)
         NS_LOG_DEBUG("Unsupported modulation received (" << modulation << "), consider as noise");
         m_interference->Add(ppdu, rxDuration, rxPowersW);
-        SwitchMaybeToCcaBusy(nullptr);
+        SwitchMaybeToCcaBusy();
     }
 }
 
+bool
+WifiPhy::IsReceivingPhyHeader() const
+{
+    return m_endPhyRxEvent.IsRunning();
+}
+
 void
 WifiPhy::EndReceiveInterBss()
 {
@@ -2088,7 +2102,7 @@
 }
 
 void
-WifiPhy::SwitchMaybeToCcaBusy(const Ptr<const WifiPpdu> ppdu)
+WifiPhy::SwitchMaybeToCcaBusy(const Ptr<const WifiPpdu> ppdu /* = nullptr */)
 {
     NS_LOG_FUNCTION(this);
     GetLatestPhyEntity()->SwitchMaybeToCcaBusy(ppdu);
@@ -2112,10 +2126,7 @@
         {
             phyEntity.second->CancelAllEvents();
         }
-        if (m_endPhyRxEvent.IsRunning())
-        {
-            m_endPhyRxEvent.Cancel();
-        }
+        m_endPhyRxEvent.Cancel();
         m_interference->NotifyRxEnd(Simulator::Now(), GetCurrentFrequencyRange());
         if (!m_currentEvent)
         {
@@ -2126,15 +2137,23 @@
         {
             m_state->SwitchFromRxAbort(GetChannelWidth());
         }
-        for (auto it = m_currentPreambleEvents.begin(); it != m_currentPreambleEvents.end(); ++it)
+        if (reason == RECEPTION_ABORTED_BY_TX)
         {
-            if (it->second == m_currentEvent)
+            Reset();
+        }
+        else
+        {
+            for (auto it = m_currentPreambleEvents.begin(); it != m_currentPreambleEvents.end();
+                 ++it)
             {
-                it = m_currentPreambleEvents.erase(it);
-                break;
+                if (it->second == m_currentEvent)
+                {
+                    it = m_currentPreambleEvents.erase(it);
+                    break;
+                }
             }
+            m_currentEvent = nullptr;
         }
-        m_currentEvent = nullptr;
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/wifi-phy-common.h ns-3.41/src/wifi/model/wifi-phy-common.h
--- ns-3.40/src/wifi/model/wifi-phy-common.h	2023-09-27 13:30:37.918840000 -0700
+++ ns-3.41/src/wifi/model/wifi-phy-common.h	2024-02-09 14:44:08.605795100 -0800
@@ -48,6 +48,9 @@
 class WifiMode;
 class Time;
 
+/// maximum propagation delay
+static constexpr uint8_t MAX_PROPAGATION_DELAY_USEC = 1;
+
 /**
  * typedef for a pair of start and stop frequencies in Hz to represent a band
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/wifi-phy.h ns-3.41/src/wifi/model/wifi-phy.h
--- ns-3.40/src/wifi/model/wifi-phy.h	2023-09-27 13:30:37.918840000 -0700
+++ ns-3.41/src/wifi/model/wifi-phy.h	2024-02-09 14:44:08.605795100 -0800
@@ -86,14 +86,14 @@
      * Add the input listener to the list of objects to be notified of
      * PHY-level events.
      */
-    void RegisterListener(WifiPhyListener* listener);
+    void RegisterListener(const std::shared_ptr<WifiPhyListener>& listener);
     /**
      * \param listener the listener to be unregistered
      *
      * Remove the input listener from the list of objects to be notified of
      * PHY-level events.
      */
-    void UnregisterListener(WifiPhyListener* listener);
+    void UnregisterListener(const std::shared_ptr<WifiPhyListener>& listener);
 
     /**
      * \param callback the callback to invoke when PHY capabilities have changed.
@@ -112,6 +112,11 @@
                               Time rxDuration);
 
     /**
+     * \return whether the PHY is busy decoding the PHY header fields of a PPDU
+     */
+    bool IsReceivingPhyHeader() const;
+
+    /**
      * For HE receptions only, check and possibly modify the transmit power restriction state at
      * the end of PPDU reception.
      */
@@ -509,6 +514,20 @@
     virtual void ConfigureStandard(WifiStandard standard);
 
     /**
+     * Set the maximum modulation class that has to be supported by this PHY object.
+     * The maximum modulation class supported will be the minimum between the given modulation
+     * class and the maximum modulation class supported based on the configured standard.
+     *
+     * \param modClass the given modulation class
+     */
+    void SetMaxModulationClassSupported(WifiModulationClass modClass);
+
+    /**
+     * \return the maximum modulation class that has to be supported by this PHY object.
+     */
+    WifiModulationClass GetMaxModulationClassSupported() const;
+
+    /**
      * Get the configured Wi-Fi standard
      *
      * \return the Wi-Fi standard that has been configured
@@ -868,7 +887,7 @@
     using ChannelTuple =
         std::tuple<uint8_t /* channel number */,
                    uint16_t /* channel width */,
-                   int /* WifiPhyBand */,
+                   WifiPhyBand /* WifiPhyBand */,
                    uint8_t /* primary20 index*/>; //!< Tuple identifying an operating channel
 
     /**
@@ -1201,12 +1220,10 @@
      * Perform any actions necessary when user changes operating channel after
      * initialization.
      *
-     * \return zero if the PHY can immediately switch channel, a positive value
-     *         indicating the amount of time to wait until the channel switch can
-     *         be performed or a negative value indicating that channel switch is
-     *         currently not possible (i.e., the radio is in sleep mode)
+     * \return the amount of time to wait until the channel switch can be performed or
+     * std::nullopt if channel switch is currently not possible (i.e., the radio is in sleep mode)
      */
-    Time GetDelayUntilChannelSwitch();
+    std::optional<Time> GetDelayUntilChannelSwitch();
     /**
      * Actually switch channel based on the stored channel settings.
      */
@@ -1218,7 +1235,7 @@
      *
      * \param ppdu the incoming PPDU or nullptr for any signal
      */
-    void SwitchMaybeToCcaBusy(const Ptr<const WifiPpdu> ppdu);
+    void SwitchMaybeToCcaBusy(const Ptr<const WifiPpdu> ppdu = nullptr);
     /**
      * Notify PHY state helper to switch to CCA busy state,
      *
@@ -1470,8 +1487,9 @@
      */
     static std::map<WifiModulationClass, Ptr<PhyEntity>>& GetStaticPhyEntities();
 
-    WifiStandard m_standard;        //!< WifiStandard
-    WifiPhyBand m_band;             //!< WifiPhyBand
+    WifiStandard m_standard;                    //!< WifiStandard
+    WifiModulationClass m_maxModClassSupported; //!< max modulation class supported
+    WifiPhyBand m_band;                         //!< WifiPhyBand
     ChannelTuple m_channelSettings; //!< Store operating channel settings until initialization
     WifiPhyOperatingChannel m_operatingChannel; //!< Operating channel
     bool m_fixedPhyBand; //!< True to prohibit changing PHY band after initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/wifi-phy-state-helper.cc ns-3.41/src/wifi/model/wifi-phy-state-helper.cc
--- ns-3.40/src/wifi/model/wifi-phy-state-helper.cc	2023-09-27 13:30:37.918840000 -0700
+++ ns-3.41/src/wifi/model/wifi-phy-state-helper.cc	2024-02-09 14:44:08.605795100 -0800
@@ -29,6 +29,7 @@
 #include "ns3/simulator.h"
 
 #include <algorithm>
+#include <functional>
 #include <iterator>
 
 namespace ns3
@@ -66,7 +67,8 @@
 }
 
 WifiPhyStateHelper::WifiPhyStateHelper()
-    : m_sleeping(false),
+    : NS_LOG_TEMPLATE_DEFINE("WifiPhyStateHelper"),
+      m_sleeping(false),
       m_isOff(false),
       m_endTx(Seconds(0)),
       m_endRx(Seconds(0)),
@@ -95,19 +97,15 @@
 }
 
 void
-WifiPhyStateHelper::RegisterListener(WifiPhyListener* listener)
+WifiPhyStateHelper::RegisterListener(const std::shared_ptr<WifiPhyListener>& listener)
 {
-    m_listeners.push_back(listener);
+    m_listeners.emplace_back(listener);
 }
 
 void
-WifiPhyStateHelper::UnregisterListener(WifiPhyListener* listener)
+WifiPhyStateHelper::UnregisterListener(const std::shared_ptr<WifiPhyListener>& listener)
 {
-    auto it = find(m_listeners.begin(), m_listeners.end(), listener);
-    if (it != m_listeners.end())
-    {
-        m_listeners.erase(it);
-    }
+    m_listeners.remove_if([&listener](auto&& weakPtr) { return weakPtr.lock() == listener; });
 }
 
 bool
@@ -231,108 +229,6 @@
 }
 
 void
-WifiPhyStateHelper::NotifyTxStart(Time duration, double txPowerDbm)
-{
-    NS_LOG_FUNCTION(this);
-    for (const auto& listener : m_listeners)
-    {
-        listener->NotifyTxStart(duration, txPowerDbm);
-    }
-}
-
-void
-WifiPhyStateHelper::NotifyRxStart(Time duration)
-{
-    NS_LOG_FUNCTION(this);
-    for (const auto& listener : m_listeners)
-    {
-        listener->NotifyRxStart(duration);
-    }
-}
-
-void
-WifiPhyStateHelper::NotifyRxEndOk()
-{
-    NS_LOG_FUNCTION(this);
-    for (const auto& listener : m_listeners)
-    {
-        listener->NotifyRxEndOk();
-    }
-}
-
-void
-WifiPhyStateHelper::NotifyRxEndError()
-{
-    NS_LOG_FUNCTION(this);
-    for (const auto& listener : m_listeners)
-    {
-        listener->NotifyRxEndError();
-    }
-}
-
-void
-WifiPhyStateHelper::NotifyCcaBusyStart(Time duration,
-                                       WifiChannelListType channelType,
-                                       const std::vector<Time>& per20MhzDurations)
-{
-    NS_LOG_FUNCTION(this);
-    for (const auto& listener : m_listeners)
-    {
-        listener->NotifyCcaBusyStart(duration, channelType, per20MhzDurations);
-    }
-}
-
-void
-WifiPhyStateHelper::NotifySwitchingStart(Time duration)
-{
-    NS_LOG_FUNCTION(this);
-    for (const auto& listener : m_listeners)
-    {
-        listener->NotifySwitchingStart(duration);
-    }
-}
-
-void
-WifiPhyStateHelper::NotifySleep()
-{
-    NS_LOG_FUNCTION(this);
-    for (const auto& listener : m_listeners)
-    {
-        listener->NotifySleep();
-    }
-}
-
-void
-WifiPhyStateHelper::NotifyOff()
-{
-    NS_LOG_FUNCTION(this);
-    for (const auto& listener : m_listeners)
-    {
-        listener->NotifyOff();
-    }
-}
-
-void
-WifiPhyStateHelper::NotifyWakeup()
-{
-    NS_LOG_FUNCTION(this);
-    for (const auto& listener : m_listeners)
-    {
-        listener->NotifyWakeup();
-    }
-}
-
-void
-WifiPhyStateHelper::NotifyOn()
-{
-    NS_LOG_FUNCTION(this);
-    for (const auto& listener : m_listeners)
-    {
-        listener->NotifyOn();
-    }
-}
-
-void
 WifiPhyStateHelper::LogPreviousIdleAndCcaBusyStates()
 {
     NS_LOG_FUNCTION(this);
@@ -404,7 +300,7 @@
     m_previousStateChangeTime = now;
     m_endTx = now + txDuration;
     m_startTx = now;
-    NotifyTxStart(txDuration, txPowerDbm);
+    NotifyListeners(&WifiPhyListener::NotifyTxStart, txDuration, txPowerDbm);
 }
 
 void
@@ -427,7 +323,7 @@
     m_previousStateChangeTime = now;
     m_startRx = now;
     m_endRx = now + rxDuration;
-    NotifyRxStart(rxDuration);
+    NotifyListeners(&WifiPhyListener::NotifyRxStart, rxDuration);
     NS_ASSERT(IsStateRx());
 }
 
@@ -460,7 +356,7 @@
     m_previousStateChangeTime = now;
     m_startSwitching = now;
     m_endSwitching = now + switchingDuration;
-    NotifySwitchingStart(switchingDuration);
+    NotifyListeners(&WifiPhyListener::NotifySwitchingStart, switchingDuration);
     NS_ASSERT(switchingDuration.IsZero() || IsStateSwitching());
 }
 
@@ -520,7 +416,7 @@
 {
     NS_LOG_FUNCTION(this);
     NS_ASSERT(m_endRx == Simulator::Now());
-    NotifyRxEndOk();
+    NotifyListeners(&WifiPhyListener::NotifyRxEndOk);
     DoSwitchFromRx();
 }
 
@@ -529,7 +425,7 @@
 {
     NS_LOG_FUNCTION(this);
     NS_ASSERT(m_endRx == Simulator::Now());
-    NotifyRxEndError();
+    NotifyListeners(&WifiPhyListener::NotifyRxEndError);
     DoSwitchFromRx();
 }
 
@@ -554,7 +450,7 @@
     {
         return;
     }
-    NotifyCcaBusyStart(duration, channelType, per20MhzDurations);
+    NotifyListeners(&WifiPhyListener::NotifyCcaBusyStart, duration, channelType, per20MhzDurations);
     if (channelType != WIFI_CHANLIST_PRIMARY)
     {
         // WifiPhyStateHelper only updates CCA start and end durations for the primary channel
@@ -591,7 +487,7 @@
     m_previousStateChangeTime = now;
     m_sleeping = true;
     m_startSleep = now;
-    NotifySleep();
+    NotifyListeners(&WifiPhyListener::NotifySleep);
     NS_ASSERT(IsStateSleep());
 }
 
@@ -604,7 +500,7 @@
     m_stateLogger(m_startSleep, now - m_startSleep, WifiPhyState::SLEEP);
     m_previousStateChangeTime = now;
     m_sleeping = false;
-    NotifyWakeup();
+    NotifyListeners(&WifiPhyListener::NotifyWakeup);
 }
 
 void
@@ -613,7 +509,7 @@
     NS_LOG_FUNCTION(this << operatingWidth);
     NS_ASSERT(IsStateCcaBusy()); // abort is called (with OBSS_PD_CCA_RESET reason) before RX is set
                                  // by payload start
-    NotifyRxEndOk();
+    NotifyListeners(&WifiPhyListener::NotifyRxEndOk);
     DoSwitchFromRx();
     m_endCcaBusy = Simulator::Now();
     std::vector<Time> per20MhzDurations;
@@ -621,7 +517,10 @@
     {
         std::fill_n(std::back_inserter(per20MhzDurations), (operatingWidth / 20), Seconds(0));
     }
-    NotifyCcaBusyStart(Seconds(0), WIFI_CHANLIST_PRIMARY, per20MhzDurations);
+    NotifyListeners(&WifiPhyListener::NotifyCcaBusyStart,
+                    Seconds(0),
+                    WIFI_CHANLIST_PRIMARY,
+                    per20MhzDurations);
     NS_ASSERT(IsStateIdle());
 }
 
@@ -657,7 +556,7 @@
     }
     m_previousStateChangeTime = now;
     m_isOff = true;
-    NotifyOff();
+    NotifyListeners(&WifiPhyListener::NotifyOff);
     NS_ASSERT(IsStateOff());
 }
 
@@ -669,7 +568,7 @@
     Time now = Simulator::Now();
     m_previousStateChangeTime = now;
     m_isOff = false;
-    NotifyOn();
+    NotifyListeners(&WifiPhyListener::NotifyOn);
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/wifi-phy-state-helper.h ns-3.41/src/wifi/model/wifi-phy-state-helper.h
--- ns-3.40/src/wifi/model/wifi-phy-state-helper.h	2023-09-27 13:30:37.918840000 -0700
+++ ns-3.41/src/wifi/model/wifi-phy-state-helper.h	2024-02-09 14:44:08.605795100 -0800
@@ -29,6 +29,8 @@
 #include "ns3/object.h"
 #include "ns3/traced-callback.h"
 
+#include <list>
+#include <memory>
 #include <vector>
 
 namespace ns3
@@ -93,13 +95,13 @@
      *
      * \param listener the WifiPhyListener to register
      */
-    void RegisterListener(WifiPhyListener* listener);
+    void RegisterListener(const std::shared_ptr<WifiPhyListener>& listener);
     /**
      * Remove WifiPhyListener from this WifiPhyStateHelper.
      *
      * \param listener the WifiPhyListener to unregister
      */
-    void UnregisterListener(WifiPhyListener* listener);
+    void UnregisterListener(const std::shared_ptr<WifiPhyListener>& listener);
     /**
      * Return the current state of WifiPhy.
      *
@@ -309,11 +311,24 @@
                                      WifiPreamble preamble,
                                      uint8_t power);
 
+    /**
+     * Notify all WifiPhyListener objects of the given PHY event.
+     *
+     * \tparam FUNC \deduced Member function type
+     * \tparam Ts \deduced Function argument types
+     * \param f the member function to invoke
+     * \param args arguments to pass to the member function
+     */
+    template <typename FUNC, typename... Ts>
+    void NotifyListeners(FUNC f, Ts&&... args);
+
   private:
     /**
-     * typedef for a list of WifiPhyListeners
+     * typedef for a list of WifiPhyListeners. We use weak pointers so that unregistering a
+     * listener is not necessary to delete a listener (reference count is not incremented by
+     * weak pointers).
      */
-    typedef std::vector<WifiPhyListener*> Listeners;
+    typedef std::list<std::weak_ptr<WifiPhyListener>> Listeners;
 
     /**
      * Log the idle and CCA busy states.
@@ -321,72 +336,16 @@
     void LogPreviousIdleAndCcaBusyStates();
 
     /**
-     * Notify all WifiPhyListener that the transmission has started for the given duration.
-     *
-     * \param duration the duration of the transmission
-     * \param txPowerDbm the nominal TX power in dBm
-     */
-    void NotifyTxStart(Time duration, double txPowerDbm);
-    /**
-     * Notify all WifiPhyListener that the reception has started for the given duration.
-     *
-     * \param duration the duration of the reception
-     */
-    void NotifyRxStart(Time duration);
-    /**
-     * Notify all WifiPhyListener that the reception was successful.
-     */
-    void NotifyRxEndOk();
-    /**
-     * Notify all WifiPhyListener that the reception was not successful.
-     */
-    void NotifyRxEndError();
-    /**
-     * Notify all WifiPhyListener that the CCA has started for the given duration.
-     *
-     * \param duration the duration of the CCA state
-     * \param channelType the channel type for which the CCA busy state is reported.
-     * \param per20MhzDurations vector that indicates for how long each 20 MHz subchannel
-     *        (corresponding to the index of the element in the vector) is busy and where a zero
-     * duration indicates that the subchannel is idle. The vector is non-empty if  the PHY supports
-     * 802.11ax or later and if the operational channel width is larger than 20 MHz.
-     */
-    void NotifyCcaBusyStart(Time duration,
-                            WifiChannelListType channelType,
-                            const std::vector<Time>& per20MhzDurations);
-    /**
-     * Notify all WifiPhyListener that we are switching channel with the given channel
-     * switching delay.
-     *
-     * \param duration the delay to switch the channel
-     */
-    void NotifySwitchingStart(Time duration);
-    /**
-     * Notify all WifiPhyListener that we are going to sleep
-     */
-    void NotifySleep();
-    /**
-     * Notify all WifiPhyListener that we are going to switch off
-     */
-    void NotifyOff();
-    /**
-     * Notify all WifiPhyListener that we woke up
-     */
-    void NotifyWakeup();
-    /**
      * Switch the state from RX.
      */
     void DoSwitchFromRx();
-    /**
-     * Notify all WifiPhyListener that we are going to switch on
-     */
-    void NotifyOn();
 
     /**
      * The trace source fired when state is changed.
      */
     TracedCallback<Time, Time, WifiPhyState> m_stateLogger;
 
+    NS_LOG_TEMPLATE_DECLARE;        //!< the log component
     bool m_sleeping;                ///< sleeping
     bool m_isOff;                   ///< switched off
     Time m_endTx;                   ///< end transmit
@@ -412,4 +371,38 @@
 
 } // namespace ns3
 
+/***************************************************************
+ *  Implementation of the templates declared above.
+ ***************************************************************/
+
+namespace ns3
+{
+
+template <typename FUNC, typename... Ts>
+void
+WifiPhyStateHelper::NotifyListeners(FUNC f, Ts&&... args)
+{
+    NS_LOG_FUNCTION(this);
+    // In some cases (e.g., when notifying an EMLSR client of a link switch), a notification
+    // to a PHY listener involves the addition and/or removal of a PHY listener, thus modifying
+    // the list we are iterating over. This is dangerous, so ensure that we iterate over a copy
+    // of the list of PHY listeners. The copied list contains shared pointers to the PHY listeners
+    // to prevent them from being deleted.
+    std::list<std::shared_ptr<WifiPhyListener>> listeners;
+    std::transform(m_listeners.cbegin(),
+                   m_listeners.cend(),
+                   std::back_inserter(listeners),
+                   [](auto&& listener) { return listener.lock(); });
+
+    for (const auto& listener : listeners)
+    {
+        if (listener)
+        {
+            std::invoke(f, listener, std::forward<Ts>(args)...);
+        }
+    }
+}
+
+} // namespace ns3
+
 #endif /* WIFI_PHY_STATE_HELPER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/wifi-radio-energy-model.cc ns-3.41/src/wifi/model/wifi-radio-energy-model.cc
--- ns-3.40/src/wifi/model/wifi-radio-energy-model.cc	2023-09-27 13:30:37.918840000 -0700
+++ ns-3.41/src/wifi/model/wifi-radio-energy-model.cc	2024-02-09 14:44:08.605795100 -0800
@@ -99,7 +99,7 @@
     NS_LOG_FUNCTION(this);
     m_energyDepletionCallback.Nullify();
     // set callback for WifiPhy listener
-    m_listener = new WifiRadioEnergyModelPhyListener;
+    m_listener = std::make_shared<WifiRadioEnergyModelPhyListener>();
     m_listener->SetChangeStateCallback(MakeCallback(&DeviceEnergyModel::ChangeState, this));
     // set callback for updating the TX current
     m_listener->SetUpdateTxCurrentCallback(
@@ -110,7 +110,7 @@
 {
     NS_LOG_FUNCTION(this);
     m_txCurrentModel = nullptr;
-    delete m_listener;
+    m_listener.reset();
 }
 
 void
@@ -387,7 +387,7 @@
     }
 }
 
-WifiRadioEnergyModelPhyListener*
+std::shared_ptr<WifiRadioEnergyModelPhyListener>
 WifiRadioEnergyModel::GetPhyListener()
 {
     NS_LOG_FUNCTION(this);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/wifi-radio-energy-model.h ns-3.41/src/wifi/model/wifi-radio-energy-model.h
--- ns-3.40/src/wifi/model/wifi-radio-energy-model.h	2023-09-27 13:30:37.918840000 -0700
+++ ns-3.41/src/wifi/model/wifi-radio-energy-model.h	2024-02-09 14:44:08.605795100 -0800
@@ -331,7 +331,7 @@
     /**
      * \returns Pointer to the PHY listener.
      */
-    WifiRadioEnergyModelPhyListener* GetPhyListener();
+    std::shared_ptr<WifiRadioEnergyModelPhyListener> GetPhyListener();
 
   private:
     void DoDispose() override;
@@ -384,7 +384,7 @@
     WifiRadioEnergyRechargedCallback m_energyRechargedCallback;
 
     /// WifiPhy listener
-    WifiRadioEnergyModelPhyListener* m_listener;
+    std::shared_ptr<WifiRadioEnergyModelPhyListener> m_listener;
 
     EventId m_switchToOffEvent; ///< switch to off event
 };
